#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
from PyQt4.QtGui import QMessageBox
from gui_modules_animation.animation_base_encodageFiltre import Base_EncodageFiltre
### Création des objets: WidgetFFmpeg2theora et WidgetFFmpeg ... l'objet WidgetMEncoder a
### été changé en conséquence #############################################################
from gui_modules_common.ffmpeg_gui import WidgetFFmpeg
from gui_modules_common.EkdWidgets import EkdSaveDialog
###########################################################################################

class AnimationEncodageHD(Base_EncodageFiltre):
	"""Cadre de Animation -> Encodage -> Haute Définition. But: encodages spécifiques haute définition (pour entre autre import des vidéos générées dans Cinelerra)"""

	def __init__(self):

		# Identifiant de la classe
		self.idSection = "animation_encodage_hd"

		# Pas d'"empilement" car pas de paramètre d'encodage
		self.stacked = None

		#----------------------------------------------------------------------------------
		# Paramètres de la liste de combo: [(identifiant, nom entrée, instance, extension), ...]
		#----------------------------------------------------------------------------------

		self.listeCombo = [
			('hd_1920x1080_mov__pcm_s16be__16/9', _(u'HD1080 16/9 (mpeg4 - pcm s16be) 1920x1080 (.mov)'), 0, '.mov'),
			('hd_1280x720_mov__pcm_s16be__16/9', _(u'HD720 16/9 (mpeg4 - pcm s16be) 1280x720 (.mov)'), 1, '.mov'),
			('hd_1440x1080_mov__pcm_s16be__4/3', _(u'HD1080 4/3 (mpeg4 - pcm s16be) 1440x1080 (.mov)'), 2, '.mov'),
			]

		#---------------------------
		# Dérivation de la classe
		#---------------------------
		Base_EncodageFiltre.__init__(self, titre=_(u"Transcodage: Haute Définition"))


	def appliquer(self, nomSortie=None, ouvert=1):
		"Appel du moteur du cadre"

		# quel est l'index du dernier item sélectionné de la boîte de combo?
		index=self.combo.currentIndex()
		if not nomSortie:

			## On utilise la nouvelle interface de récupération des vidéos
			# Récupération du chemin source
			chemin=unicode(self.getFile())

			# suffix du codec actif
			suffix=self.listeCombo[index][3]
			if suffix=='':
				suffix=os.path.splitext(chemin)[1]
				
			ext_chargee = os.path.splitext(chemin)[1]
			codec_reglage = self.listeCombo[index][1]
			#######################################################################
				
			# suffix du codec actif
			saveDialog = EkdSaveDialog(self, os.path.expanduser(self.repSortieProv()), suffix, _(u"Sauver"))
			cheminFichierEnregistrerVideo = saveDialog.getFile()
			######################################################################################################################

		else: # module séquentiel
			cheminFichierEnregistrerVideo = nomSortie

		if not cheminFichierEnregistrerVideo:
			return

		# quel est l'index du dernier item sélectionné de la boîte de combo?
		#i = self.combo.currentIndex()
		print 'index', index
		# identifiant du codec actif
		idCodec = self.listeCombo[index][0]
		print 'idCodec', idCodec

		######## Gestion de l'extension .h264 ####
		# Si on charge une vidéo avec extension .h264, FFmpeg ne peut 
		# pas effectuer l'encodage
		if ext_chargee == '.h264':
			messErrExtH264ffmpeg=QMessageBox(self)
			messErrExtH264ffmpeg.setText(_(u"<p>Il n'est pas possible de donner suite au traitement <b>à partir d'une vidéo avec extension h264 et en ayant choisi: %s.</b></p><p><b>Veuillez choisir une autre vidéo (sans extension h264).</b></p>" % codec_reglage))
			messErrExtH264ffmpeg.setWindowTitle(_(u"Erreur"))
			messErrExtH264ffmpeg.setIcon(QMessageBox.Warning)
			messErrExtH264ffmpeg.exec_()
			return
		else:
			# Condition pour détection windows
#			if os.name == 'nt':
			mencoder = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, laisserOuvert=ouvert)
			# Condition pour détection Linux
			#elif os.name in ['posix', 'mac']:
				#mencoder = WidgetFFmpeg(idCodec, chemin, cheminFichierEnregistrerVideo, laisserOuvert=ouvert)
			mencoder.setWindowTitle(_(u"Encodage vidéo - Haute Définition"))
			mencoder.exec_()

		#########################################################################################

                self.lstFichiersSortie = cheminFichierEnregistrerVideo
		self.radioConvert.setChecked(True)
		self.radioSource.setEnabled(True)
		self.radioSource.setChecked(False)
		self.radioConvert.setEnabled(True)
		self.boutCompare.setEnabled(True)
		### Information à l'utilisateur
		self.infoLog(None, chemin, None, cheminFichierEnregistrerVideo)

		return cheminFichierEnregistrerVideo # module séquentiel

	def afficherAide(self):
		"""Boîte de dialogue de l'aide du cadre"""
		
		super( AnimationEncodageHD,self).afficherAide(_(u"<p><b>Vous pouvez ici transformer une vidéo de qualité ordinaire en vidéo 'Haute Définition' et en suivant les standards de la HD, c'est à dire HD 1080 16/9 (dont la résolution sera par défaut: 1920 x 1080), HD 720 16/9 (dont la résolution sera par défaut: 1280 x 720) et HD 1080 4/3 (dont la résolution sera par défaut: 1440 x 1080). Les vidéos résultantes (dans beaucoup de cas) verront leur qualité s'améliorer.</b></p><p>Dans l'onglet <b>'Vidéo(s) source'</b> cliquez sur le bouton <b>Ajouter</b>, une boîte de dialogue apparaît, sur la partie gauche sélectionnez le répertoire (au besoin dépliez les sous-répertoires), allez chercher la/les vidéo(s). Si vous voulez sélectionner plusieurs vidéos d'un coup, maintenez la touche <b>CTRL</b> (ou <b>SHIFT</b>) du clavier enfoncée (tout en sélectionnant vos vidéos), cliquez sur <b>Ajouter</b>.</p><p>Vous pouvez dès lors sélectionner une vidéo dans la liste et la visionner (par le bouton juste à la droite de cette liste), vous noterez que vous pouvez visionner la vidéo en quatre tiers, en seize neuvième ou avec les proportions d'origine de la vidéo (w;h). De même si vous le désirez, vous pouvez obtenir des informations complètes sur la vidéo sélectionnée, et ce par le bouton <b>'Infos'</b> (en bas).</p><p>Dans l'onglet <b>'Réglages'</b> sélectionnez le type d'encodage que vous voulez faire.</p><p>Une fois tout ceci fait, cliquez sur le bouton <b>'Appliquer'</b>, sélectionnez le répertoire de sauvegarde, indiquez votre <b>'Nom de fichier'</b>, cliquez sur le bouton <b>'Enregistrer'</b> et attendez le temps de la conversion. A la fin cliquez sur le bouton <b>'Voir les informations d'encodage'</b> et fermez cette dernière fenêtre après avoir vu les informations en question.</p><p>Dans l'onglet <b>'Visionner vidéo'</b> vous pouvez visionner le résultat (avant la conversion) en sélectionnant <b>'vidéo(s) source(s)'</b>, après la conversion <b>'vidéo convertie'</b> ou bien encore les deux en même temps, en cliquant sur le bouton <b>'Comparateur de vidéos'</b>.</p><p>L'onglet <b>'Infos'</b> vous permet de voir les vidéos chargées (avec leurs chemins exacts) avant et après conversion.</p>"))
